#include "stdafx.h"		// Standard MFC libraries
#include "cfx.h"		// CFX Custom Tag API
#include "windows.h"	// Windows Functions, GlobalMemoryStatus

void ProcessTagRequest( CCFXRequest* pRequest ) 
{
	try
	{
		CString buffer;
		MEMORYSTATUS stat;

		if (!pRequest->AttributeExists("VARIABLE")) {
			pRequest->ThrowException( 
				"Error occurred in tag CFX_GETMEMORYSTATUS",
				"Required attribute VARIABLE missing." ) ;	
		}
		CString var = pRequest->GetAttribute("VARIABLE");

		//get memory statistics
		GlobalMemoryStatus(&stat);
		//free physical memory
		unsigned long freeMem = stat.dwAvailPhys;
		//convert long to string
		ltoa(freeMem, buffer.GetBuffer(16), 10);
		
		pRequest->SetVariable(var + ".freeMemory", buffer);

		//total physical memory
		unsigned long totalMem = stat.dwTotalPhys;
		//convert long to string
		ltoa(totalMem, buffer.GetBuffer(16), 10);
		
		pRequest->SetVariable(var + ".totalMemory", buffer);
		
		//more windows specific memory info
		unsigned long availablePageFile = stat.dwAvailPageFile;
		ltoa(availablePageFile, buffer.GetBuffer(16), 10);
		pRequest->SetVariable(var + ".availablePageFile", buffer);
		
		unsigned long availableVirtual = stat.dwAvailVirtual;
		ltoa(availableVirtual, buffer.GetBuffer(16), 10);
		pRequest->SetVariable(var + ".availableVirtual", buffer);

		unsigned long memoryLoad = stat.dwMemoryLoad;
		ltoa(memoryLoad, buffer.GetBuffer(16), 10);
		pRequest->SetVariable(var + ".memoryLoad", buffer);

		unsigned long totalPageFile = stat.dwTotalPageFile;
		ltoa(totalPageFile, buffer.GetBuffer(16), 10);
		pRequest->SetVariable(var + ".totalPageFile", buffer);

		unsigned long totalVirtual = stat.dwTotalVirtual;
		ltoa(totalVirtual, buffer.GetBuffer(16), 10);
		pRequest->SetVariable(var + ".totalVirtual", buffer);

	}

	// Catch Cold Fusion exceptions & re-raise them
	catch( CCFXException* e )
	{
		pRequest->ReThrowException( e ) ;
	}
	
	// Catch ALL other exceptions and throw them as 
	// Cold Fusion exceptions (DO NOT REMOVE! -- 
	// this prevents the server from crashing in 
	// case of an unexpected exception)
	catch( ... )
	{
		pRequest->ThrowException( 
			"Error occurred in tag CFX_GETMEMORYSTATUS",
			"Unexpected error occurred while processing tag." ) ;
	}
}
