#include "stdafx.h"		// Standard MFC libraries, remove for unix
#include "cfx.h"		// CFX Custom Tag API
#include <string>		// Use STL String for unix

void ProcessTagRequest( CCFXRequest* pRequest ) 
{
	try
	{
		CCFXQuery * pInputQuery = pRequest->GetQuery();
		if (pInputQuery == NULL) {
			pRequest->ThrowException( 
				"Error occurred in tag CFX_REVERSEQUERY",
				"Required attribute QUERY missing." ) ;
		}
		if (!pRequest->AttributeExists("RESULT")) {
			pRequest->ThrowException( 
				"Error occurred in tag CFX_REVERSEQUERY",
				"Required attribute RESULT missing." ) ;
		}
		
		std::string strResult = pRequest->GetAttribute("RESULT");

		CCFXStringSet * pColumns = pInputQuery->GetColumns();
		int iColumns = pColumns->GetCount();

		int iRows = pInputQuery->GetRowCount();
		
		CCFXQuery * pResultQuery = pRequest->AddQuery(strResult.c_str(), pColumns);
		
		
		//reverse the query
        for(int r=iRows;r>0;r--) {
            int row = pResultQuery->AddRow();
            for (int c=1;c<=iColumns;c++) {
				std::string strData = pInputQuery->GetData(r, c);
				pResultQuery->SetData(row, c, strData.c_str());
            }
        }

	}

	// Catch Cold Fusion exceptions & re-raise them
	catch( CCFXException* e )
	{
		pRequest->ReThrowException( e ) ;
	}
	
	// Catch ALL other exceptions and throw them as 
	// Cold Fusion exceptions (DO NOT REMOVE! -- 
	// this prevents the server from crashing in 
	// case of an unexpected exception)
	catch( ... )
	{
		pRequest->ThrowException( 
			"Error occurred in tag CFX_REVERSEQUERY",
			"Unexpected error occurred while processing tag." ) ;
	}
}
