
import com.allaire.cfx.*;

public class CFX_ReverseQuery
    implements CustomTag
{
    public void processRequest(Request request, Response response) 
        throws Exception 
    {
        Query inputQuery = request.getQuery();
        
        if (inputQuery == null) {
            throw new Exception("Required attribute QUERY missing.");
        }
        if (!request.attributeExists("RESULT")) {
            throw new Exception("Required attribute RESULT missing.");
        }
        
        String resultQueryName = request.getAttribute("RESULT");
        String[] columns = inputQuery.getColumns();
        
        Query result = response.addQuery(resultQueryName, columns);
        
        int rowCount = inputQuery.getRowCount();
        
        //reverse the query
        for(int r=rowCount;r>0;r--) {
            int row = result.addRow();
            for (int c=1;c<=columns.length;c++) {
                String data = inputQuery.getData(r, c);
                result.setData(row, c, data);
            }
        }
        
        
        
        
    }
    
}
