#include "stdafx.h"		// Standard MFC libraries, remove on unix
#include "cfx.h"		// CFX Custom Tag API
#include <string>		// Use STL string for unix compatibility

void ProcessTagRequest( CCFXRequest* pRequest ) 
{
	try
	{
		if (!pRequest->AttributeExists("STRING")) {
			pRequest->ThrowException("Error occurred in tag CFX_SUBSTRING",
			"Required attribute STRING missing" ) ;
		}

		if (!pRequest->AttributeExists("START")) {
			pRequest->ThrowException("Error occurred in tag CFX_SUBSTRING",
			"Required attribute START missing" ) ;
		}

		std::string str = pRequest->GetAttribute("STRING");
		std::string strStart = pRequest->GetAttribute("START");
		int iStart = atoi(strStart.c_str());

		if (pRequest->AttributeExists("END")) {
			std::string strEnd = pRequest->GetAttribute("END");
			int iEnd = atoi(strEnd.c_str());
			str = str.substr(iStart, iEnd);
		}
		else {
			str = str.substr(iStart);
		}
		
		pRequest->Write(str.c_str());

		
	}

	// Catch Cold Fusion exceptions & re-raise them
	catch( CCFXException* e )
	{
		pRequest->ReThrowException( e ) ;
	}
	
	// Catch ALL other exceptions and throw them as 
	// Cold Fusion exceptions (DO NOT REMOVE! -- 
	// this prevents the server from crashing in 
	// case of an unexpected exception)
	catch( ... )
	{
		pRequest->ThrowException( 
			"Error occurred in tag CFX_SUBSTRING",
			"Unexpected error occurred while processing tag." ) ;
	}
}
