#include "stdafx.h"		// Standard MFC libraries
#include "windows.h"	// Windows Functions, GlobalMemoryStatus
#include "cfx.h"		// CFX Custom Tag API


void ProcessTagRequest( CCFXRequest* pRequest ) 
{
	try
	{
		CString buffer;
		MEMORYSTATUS stat;

		//get memory statistics
		GlobalMemoryStatus(&stat);
		//free physical memory
		unsigned long freeMem = stat.dwAvailPhys;
		freeMem /= 1024; //convert from bytes to KB
		//convert long to string
		ltoa(freeMem, buffer.GetBuffer(16), 10);
		pRequest->Write(buffer);
		pRequest->Write("KB of physical memory is free.<br>");

		//free physical memory
		unsigned long totalMem = stat.dwTotalPhys;
		totalMem /= 1024; //convert from bytes to KB
		//convert long to string
		ltoa(totalMem, buffer.GetBuffer(16), 10);
		pRequest->Write(buffer);
		pRequest->Write("KB of physical memory total.<br>");
	}

	// Catch Cold Fusion exceptions & re-raise them
	catch( CCFXException* e )
	{
		pRequest->ReThrowException( e ) ;
	}
	
	// Catch ALL other exceptions and throw them as 
	// Cold Fusion exceptions (DO NOT REMOVE! -- 
	// this prevents the server from crashing in 
	// case of an unexpected exception)
	catch( ... )
	{
		pRequest->ThrowException( 
			"Error occurred in tag CFX_WRITEMEMORYSTATUS",
			"Unexpected error occurred while processing tag." ) ;
	}
}
